// pages/feedback/feedback.js
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    screenHeight: '', //屏幕可视高度
    areaID: 0, //区域id
    value1: 0, //第一个显示什么
    option1: [],
    curPage: 0, //tab切换 【1 已读  0未读】
    feedList: [], //用户反馈列表
    page: 1,
    option1:[],
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let that = this;
    that.setData({
      screenHeight: app.globalData.screenHeight,
      option1: wx.getStorageSync('allArea'),
    })
    let curVal = wx.getStorageSync('curVal');
    if (curVal) {
      that.setData({
        value1: curVal
      })
    }
    let areaID = wx.getStorageSync('curId')
    if (areaID) {
      that.setData({
        areaID
      })
    } else {
      let id = that.data.option1[0].areaID
      that.setData({
        areaID: id
      })
    }
    that.menu = that.selectComponent("#menu");
    that.menu.changeTitle(that.data.option1[that.data.value1].text);
    this.getFeed();
  },
  goTop: function (e) { // 一键回到顶部
    if (wx.pageScrollTo) {
      wx.pageScrollTo({
        scrollTop: 0
      })
    }
  },
  //获取反馈列表
  getFeed() {
    wx.showLoading({
      title: '加载中',
    })
    let areaID = this.data.areaID;
    let is_read = this.data.curPage;
    app.request('user/feedback?is_read=' + is_read + '&area_id=' + areaID, '', 'GET').then(res => {
      wx.hideLoading()
      console.log(res.data.data);
      let feed = res.data.data;
      if (feed) {
        this.setData({
          feedList: res.data.data
        })
      } else {
        wx.showToast({
          title: '暂无反馈信息~',
          icon: 'none'
        })
      }

    })
  },
  //标记为已读
  markRead(e) {
    let id = e.currentTarget.dataset.id;
    app.request('user/feedback/read?id=' + id, '', 'GET').then(res => {
      console.log(res);
        this.getFeed();
    })
  },
  //返回键
  back() {
    wx.navigateBack({
      delta: 1
    })
  },
  //选择区域
  change: function (e) {
    let that = this;
    wx.setStorageSync('curVal', that.data.option1[e.detail].value)
    wx.setStorageSync('curId', that.data.option1[e.detail].areaID)
    this.setData({
      areaID: that.data.option1[e.detail].areaID
    })
    this.getFeed();
    this.goTop();
  },
  //tab 切换
  choose(e) {
    let idx = e.currentTarget.dataset.idx;
    this.setData({
      curPage: idx
    })
    this.getFeed();
    this.goTop();
  },
  moreFeed() {
    wx.showLoading({
      title: '加载中...',
    })
    let that = this;
    var page = that.data.page + 1;
    let read = that.data.curPage;
    let areaID = that.data.areaID;
    app.request('user/feedback?is_read=' + read + '&page=' + page + '&area_id=' + areaID, '', 'GET').then(res => {
      wx.hideLoading();
        wx.hideLoading();
        if (res.data.data.length > 0) {
          console.log(res)
          this.setData({
            feedList: this.data.feedList.concat(res.data.data)
          })
        } else {
          wx.showToast({
            title: '没有更多数据了~',
            icon: 'none'
          })
        }
    })

  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    wx.showLoading({
      title: '加载中',
    })
    this.moreFeed();
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})