const app = getApp();
Page({
  data: {
    latitude: "24.47951",
    longitude: "118.08948",
    markers: [], //点
    polyline: [], //线
    polygons: [], //区域
    list: [],
    fence: [], //点击地图获取的经纬度
    type: '', //停车区类型
    parkName: '', //停车区名称
    markShow: false, //是否显示停车点名称
    parkId: '', //停车点/禁停区id
    detail: [],
    showPop: false, //是否显示弹窗
    areaList: [], //选择所属大区列表
    typeList: [{ //区域类型选项
      type: 1,
      name: '禁停区'
    }, {
      type: 2,
      name: '停车区'
    }],
    options: '',
    parkNum: 0, //停车上限
    mapclick: false, //是否执行地图点击事件
    areaChecked: true, //弹窗区域的状态
    areaId: '', //区域id
    btnShow: false, //重绘  取消
    pushShow: true,
    areaName: '',
    satellite: false, //是否显示卫星地图
    newArea: {}, // 新添加的停车点或者禁停区
    areaID: 0,
    value1: 0, //第一个显示什么
    option1: [],
    rideArea: [], //骑行区
    screenHeight: '', //屏幕可视高度
  },
  onLoad(options) {
    let that = this;
    that.setData({
      screenHeight: app.globalData.screenHeight,
      option1: wx.getStorageSync('allArea'),
      areaList:wx.getStorageSync('allArea'),
    })
    let curVal = wx.getStorageSync('curVal');
    if (curVal) {
      that.setData({
        value1: curVal
      })
    }
    let areaID = wx.getStorageSync('curId')
    if (areaID) {
      that.setData({
        areaID
      })
    } else {
      let id = that.data.option1[0].areaID
      that.setData({
        areaID: id
      })
    }
    that.menu = that.selectComponent("#menu");
    that.menu.changeTitle(that.data.option1[that.data.value1].text);
    that.park(); // 获取停车区
    that.getArea(); //获取骑行区
    wx.getLocation({
      type: 'gcj02',
      success: function (res) {
        let latitude = res.latitude;
        let longitude = res.longitude;
        console.log(latitude, longitude)
        that.setData({
          latitude: latitude,
          longitude: longitude
        })
      },
    })
  },
  back() {
    wx.navigateBack({
      delta: 1
    })
  },
  change: function (e) {
    let that = this;
    wx.setStorageSync('curVal', that.data.option1[e.detail].value)
    wx.setStorageSync('curId', that.data.option1[e.detail].areaID)
    this.setData({
      areaID: that.data.option1[e.detail].areaID,
      value1:that.data.option1[e.detail].value
    })
    this.park()
  },
  bindPickerChange: function (e) {
    let nowArea = this.data.option1[e.detail.value].text
    let areaId = this.data.option1[e.detail.value].areaID
    this.setData({
      areaName: nowArea,
      areaId
    })
  },
  bindPickerChange1: function (e) {
    let nowType = this.data.typeList[e.detail.value].name
    let type = this.data.typeList[e.detail.value].type
    this.setData({
      typeName: nowType,
      type
    })
  },
  //添加还车点、禁停区
  push() {
    let areaName = this.data.option1[0].text;
    console.log(this.data.option1[0].text)
    let typeName = this.data.typeList[1].name;
    let areaId = this.data.option1[0].areaID;
    let type = this.data.typeList[1].type
    this.setData({
      showPop: true,
      parkName: '',
      parkNum: 0,
      areaChecked: true,
      markShow: false,
      areaName,
      typeName,
      type,
      areaId,
    })
  },
  posi: function () {
    //点击定位  
    var that = this;
    wx.getLocation({
      type: 'gcj02',
      success: (res) => {
        var latitude = res.latitude
        var longitude = res.longitude
        that.setData({
          longitude: longitude,
          latitude: latitude
        })
      },
      fail: function (err) {
        console.log(err)
      }
    })
  },
  refresh() {
    wx.showLoading({
      title: '刷新中...',
    })
    this.setData({
      markShow: false
    })
    this.park();
  },
  sateposi() {
    let that = this;
    that.setData({
      satellite: !that.data.satellite
    })
  },
  //停车（禁停）区名称
  bindKeyInput(e) {
    this.setData({
      parkName: e.detail.value
    })
  },
  //选择区域类型
  choiceType() {
    this.setData({
      showType: !this.data.showType
    })
  },
  // 停车上限
  numInput(e) {
    this.setData({
      parkNum: e.detail.value
    })
  },
  // 改变区域状态
  changeState() {
    this.setData({
      areaChecked: !this.data.areaChecked
    })
  },
  //绘制围栏
  draw() {
    let that = this;
    if (!that.data.areaName) {
      wx.showToast({
        title: '请选择所属大区',
        icon: 'none'
      })
    } else if (!that.data.parkName) {
      wx.showToast({
        title: '停车区域名称不能为空',
        icon: 'none'
      })
    } else if (!that.data.typeName) {
      wx.showToast({
        title: '请选择区域类型',
        icon: 'none'
      })
    } else if (that.data.parkNum === '') {
      wx.showToast({
        title: '请输入停车上限',
        icon: 'none'
      })
    } else {
      let data = {
        name: this.data.parkName
      }
      app.request('parking/UniqueParkingName', data, 'POST').then(res => {
          if (res.data.status == 0) {
            wx.showToast({
              title: '停车区域名称已存在',
              icon: 'none'
            })
          } else {
            wx.getSystemInfo({
              success: (res) => {
                console.log(1111)
                this.setData({
                  controls: [{
                    id: 1,
                    iconPath: '/img/lock.png', //  中心点图片
                    position: {
                      left: res.windowWidth / 2 - 9,
                      top: res.windowHeight / 2 - 27,
                      width: 45,
                      height: 45
                    },
                    clickable: true
                  }]
                })
              }
            })
            that.setData({
              showPop: false,
              mapclick: true,
              pushShow: false
            })
            wx.showToast({
              title: '请点击地图进行绘制',
              icon: 'none'
            })
          }
      })
    }
  },
  //取消
  cancel() {
    this.setData({
      showPop: false,
      pushShow: true
    })
  },

  //地图上绘制停车区
  controltap(e) {
    let that = this;
    let mapCtx = wx.createMapContext("map");
    let arr = that.data.list;
    mapCtx.getCenterLocation({
      success: function (res) {
        var latitude = res.latitude
        var longitude = res.longitude
        var color = '';
        var bgColor = '';
        var iconPath = '';
        if (that.data.type == 1) { //禁停区
          iconPath = "http://resource.bike.hanyiyun.com/redStop.png";
          color = "#FF0000";
          bgColor = "#FF000002";
        } else if (that.data.type == 2) { //停车区
          iconPath = "http://resource.bike.hanyiyun.com/stop1.png";
          color = "#ff00ff";
          bgColor = "#ff00ff02"
        }
        let obj = {
          latitude,
          longitude
        };
        arr.push(obj);
        console.log(arr, 'arr')
        if (arr.length == 1) {
          let dot = {}
          dot.latitude = arr[0].latitude;
          dot.longitude = arr[0].longitude;
          dot.width = 28;
          dot.height = 28;
          dot.iconPath = iconPath;
          let dotArr = [];
          dotArr.push(dot)
          that.setData({
            markers: that.data.markers.concat(dotArr)
          })
        }
        if (arr.length == 2) {
          let line = {};
          line.points = arr;
          line.width = 4;
          line.borderWidth = 3;
          line.borderColor = color;
          line.color = color;
          let lineArr = [];
          lineArr.push(line);
          that.data.markers.splice(that.data.markers.length - 1, 1)
          that.setData({
            polyline: lineArr,
            markers: that.data.markers
          })
        }
        if (arr.length >= 3) {
          let area = {};
          that.setData({
            fence: arr,
            btnShow: true
          })
          area.points = arr;
          area.fillColor = bgColor;
          area.strokeColor = color;
          area.strokeWidth = 4;
          area.zIndex = 1;
          let areaArr = []
          areaArr.push(area)
          that.setData({
            polygons: that.data.polygons.concat(areaArr),
            polyline: ''
          })
        }
      }
    })
  },
  //停车点和禁停点
  park() {
    wx.showLoading({
      title: '加载中...',
    })
    var that = this;
    // let url = ''
    // if (!that.data.areaID) {
    //   url = 'parking'
    // } else {
    let url = 'parking?area_id=' + that.data.areaID
    // }
    that.getArea();
    app.request(url, '', 'GET').then(res => {
      wx.hideLoading();
      console.log(res.data.parking_area)
      let polygons = res.data.parking_area.concat(that.data.rideArea);
      that.setData({
        markers: res.data.point,
        polygons: polygons
      })
    })
  },
  // 获取骑行区
  getArea() {
    var that = this;
    // let url = ''
    // if (!that.data.areaID) {
    //   url = 'getAreas?is_with_parking=' + 0
    // } else {
    let url = 'getAreas?put_area_id=' + that.data.areaID + "&&is_with_parking=" + 0
    // }
    app.request(url, '', 'GET').then(res => {
      // console.log(res.data.ridding_area);
      that.setData({
        rideArea: res.data.ridding_area
      })
    })
  },
  //停车（禁停）图标点击事件
  markertap({
    markerId
  }) {
    let that = this;
    that.getPark_info(markerId)
    that.setData({
      parkId: markerId
    })
  },
  //获取停车（禁停）点信息
  getPark_info: function (parkId) {
    wx.showLoading({
      title: '加载中...',
    })
    app.request('parking/' + parkId.slice(1), '', 'GET').then(res => {
      wx.hideLoading();
      this.setData({
        detail: res.data,
        markShow: true
      })
    })
  },
  //删除当前停车（禁停点）
  remove(e) {
    console.log(e);
    var that = this;
    console.log(that.data.parkId, 'parkId')
    wx.showModal({
      title: '提示',
      content: '确定删除该区域吗？',
      success: function (res) {
        if (res.confirm) {
          console.log(res,"ppppp")
          app.request('parking/' + that.data.parkId.slice(1), '', 'DELETE').then(res => {
            console.log(res,'删除成功')
          })
         
          that.park();
          that.setData({
            markShow: false
          })
        }
      }
    })
  },
  //停车区状态
  switchCon: function () {
    wx.showLoading({
      title: '修改中...',
    })
    var that = this;
    console.log(that)
    let detail = that.data.detail
    detail.status = !detail.status;
    let status = '';
    if (detail.status == true) {
      status = 1
    } else {
      status = 0
    }
    that.setData({
      detail
    })
    let data = {
      status,
      id: that.data.parkId
    }
    app.request('parking/status', data, 'POST').then(res => {
      wx.hideLoading();
        wx.showToast({
          title: '修改成功',
          icon: 'none'
        })
    })
  },
  //重绘
  again() {
    this.getArea();
    this.setData({
      polygons: [],
      markers: [],
      polyline: [],
      list: [],
      btnShow: false
    })
    this.park();
  },
  cancelBtn() {
    this.setData({
      mapclick: false,
      markers: [],
      pushShow: true,
      controls: [],
      polygons: [],
      polyline: [],
      list: [],
    })
    this.park();
  },
  //完成
  finish() {
    let that = this;
    if (that.data.fence.length >= 3) {
      let state = JSON.parse(that.data.areaChecked);
      let parking_fence = []
      that.data.fence.map(i => {
        parking_fence.push({
          lat: i.latitude,
          lng: i.longitude
        })
      })
      if (state) {
        state = 1
      } else {
        state = 0
      }
      let data = {
        parking_fence: JSON.stringify(parking_fence),
        area_id:wx.getStorageSync('curId'),
        max_number: that.data.parkNum,
        name: that.data.parkName,
        status: state,
        type: that.data.type,
      }
      app.request('parking', data, 'POST').then(res => {
        if (res.statusCode == 201) {
          console.log(that.data.type, 555)
          console.log(res, '添加');
          wx.showToast({
            title: '添加成功',
            icon: 'none',
            duration: 3000,
            success: function () {
              that.setData({
                mapclick: false,
                pushShow: true,
                controls: [],
                list: [],
                polygons: [],
                polyline: [],
                markers: []
              })
              that.park();
            }
          })
        }
      })
    } else {
      wx.showToast({
        title: '请至少选择三个点',
        icon: 'none'
      })
    }

  },
})