const formatTime = date => {
  const year = date.getFullYear()
  const month = date.getMonth() + 1
  const day = date.getDate()
  const hour = date.getHours()
  const minute = date.getMinutes()
  const second = date.getSeconds()

  return [year, month, day].map(formatNumber).join('/') + ' ' + [hour, minute, second].map(formatNumber).join(':')
}

const formatNumber = n => {
  n = n.toString()
  return n[1] ? n : '0' + n
}
import {
  commonLabel,
  homeLabel
} from './config';
/* 
回调
(latitude,longitude)=>{}
*/
function getLocation(baseUtil = '', callBack, type = '') {
  let app = getApp();
  let lang = app.systemInfo.lang;
  wx.getLocation({
    type: 'gcj02',
    success: (res) => {
      let latitude = res.latitude;
      let longitude = res.longitude;
      callBack(latitude, longitude)
    },
    fail: () => {
      if (baseUtil != '')
        baseUtil.showToast(commonLabel[lang].locationFail);
    }

  });
}
function getXTrackingId() {
  let chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'];
  let XTrackingId = "";
  for (let i = 0; i < 32; i++) {
    let id = parseInt(Math.random() * 61);
    XTrackingId += chars[id];
  }
  return XTrackingId;
}
module.exports = {
  formatTime: formatTime,
  getLocation: getLocation,
  getXTrackingId: getXTrackingId,
}
