let systemInfo, selectCallBack, confirmCallback;
import {
  selectLabel
} from './config'
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    toastText: {
      type: String,
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    showTitleCon: false,
    showBackBtn: false,
    titleName: '',
    statusBarHeight: 0,
    showLoading: false,
    showToast: false,
    toastContent: '',
    topPadding: 0,
    showSelect: false,
    isCenter: true,
    selectTip: '',
    selectContent: '',
    confirmText: '',
    cancelText: '',
    showDialog: false,
    dialogContent: '',
    confirmText: ''
  },
  ready: function () {
    let that = this;
    that.initData();
  },
  /**
   * 组件的方法列表
   */
  methods: {
    return:function(){
      return;
    },
    showDialog: function (params, callBack) {
      let that = this;
      confirmCallback = callBack;
      that.setData({
        showDialog: true,
        dialogContent: params.content != undefined ? params.content : '',
        confirmText: params.confirmText != undefined ? params.confirmText : selectLabel[systemInfo.lang]['confirmText'],
      })
    },
    hiddenDialog: function (e) {
      let that = this;
      that.setData({
        showDialog: false
      });
      if (confirmCallback != undefined)
        confirmCallback();
    },
    /*用户提示对话框
    \n表示换行
     */
    showToast: function (content) {
      let that = this;
      that.setData({
        showLoading: false,
        showSelect: false,
        showToast: true,
        toastContent: content
      });
      let timer = setTimeout((res) => {
        that.setData({
          showToast: false,
        });
        clearTimeout(timer);
      }, 3000)
    },
    /* 展示自定义加载框
     */
    showLoading: function (type) {
      if (type == 'full') {
        this.setData({
          topPadding: 0
        })
      }
      this.setData({
        showLoading: true,
      })
    },
    /* 隐藏自定义加载框
     */
    hiddenLoading: function () {
      this.setData({
        // topPadding: systemInfo.statusBarHeight + 45,
        showLoading: false,
      })
    },
    /* 初始化数据
     */
    initData: function () {
      let that = this;
      wx.getSystemInfo({
        success: function (res) {
          console.log(res, 'system');
          if (res.errMsg === 'getSystemInfo:ok') {
            that.setData({
              statusBarHeight: res.statusBarHeight,
              topPadding: res.statusBarHeight + 45
            });
            res.lang = res.language.indexOf('zh') !== -1 ? 'zh' : 'en';
            systemInfo = res;
            that.setData({
              selectTip: selectLabel[systemInfo.lang]['selectTip'],
              confirmText: selectLabel[systemInfo.lang]['confirmText'],
            })

          }
        },
      });
    },
    /* 展示选择对话框
     */
    showSelectDailog: function (params, callBack) {
      let that = this;
      that.setData({
        showSelect: true,
        isCenter: params.isCenter != undefined ? params.isCenter : true,
        selectTip: params.selectTip != undefined ? params.selectTip : selectLabel[systemInfo.lang]['selectTip'],
        selectContent: params.selectContent != undefined ? params.selectContent : selectLabel[systemInfo.lang]['content'],
        confirmText: params.confirmText != undefined ? params.confirmText : selectLabel[systemInfo.lang]['confirmText'],
        cancelText: params.cancelText != undefined ? params.cancelText : selectLabel[systemInfo.lang]['cancelText'],
      });
      selectCallBack = callBack;
    },

    hiddeenSelectDialog: function (e) {
      let that = this;
      that.setData({
        showSelect: false
      });
      selectCallBack(e.currentTarget.dataset.state);
    }
  }
})